KBD         = $A000

            .code
            .export KBD_GETCH

; Poll keyboard for keypress
; ACC = keypress ASCII code
; X
; Y

KBD_GETCH:  BIT KBD
            BPL KBD_GETCH
            TYA
            PHA
            LDX #$04
RELEASE:    CPX #$00
            BEQ SKIP
            DEX
            LDY #$FF
LOOP2:      DEY
            BNE LOOP2
SKIP:       BIT KBD
            BMI RELEASE
            PLA
            TAY
            LDA KBD
            AND #$0F        ; Remove unwanted bits (16 keys, 4 bits)
            CPX #$00        ; Check if long press ("uppercase")
            BNE LOWERCASE
            ORA #$10        ; Add "uppercase" offset
LOWERCASE:  TAX
            LDA KBDLUT,X
            RTS

KBDLUT:     .byte $7F,"321",$7F,"654",$7F,"987",$0D,".0:"
            .byte $7F,"CBA",$00,"FED",$00,"987","R",". :"